import * as monaco from 'monaco-editor';
import { State } from './state';
export declare class EmacsExtension implements monaco.IDisposable {
    private _editor;
    private _disposables;
    private _inSelectionMode;
    private _changeDisposable;
    private _throttledScroll;
    private _intialCursorType;
    private _intialCursorBlinking;
    private _basicInputWidget;
    private _state;
    private _onDidMarkChange;
    onDidMarkChange: import("./util").Event<boolean>;
    private _onDidChangeKey;
    onDidChangeKey: import("./util").Event<string>;
    constructor(editor: monaco.editor.IStandaloneCodeEditor);
    start(): void;
    readonly state: State;
    getEditor(): monaco.editor.IStandaloneCodeEditor;
    private addListeners;
    private cancelKey;
    private onKeyDown;
    onEditorScroll(): void;
    private onContentChange;
    clearState(): void;
    selectionMode: boolean;
    getCursorAnchor(): monaco.Position;
    getBasicInput(message: string): Promise<string>;
    dispose(): void;
}
